clear all;close all; clc
hndl = pmdOpen('pmdfile.W64.pcp','recording2.pmd','camboardnanoproc','');

pmdUpdate(hndl);
dist = pmdGetDistances(hndl);
% dist = -dist;
figure(1);
color = [1 1 1];
triangleMat = nan(165,120);

%extra filters
% need filter based on number of surrounding triangles, if too few
% then SM clearly can't step there, so remove them

%turn on to filter out noise and bad pixels
%filters use magic numbers, still need to empirically assess depth data
%19516 polygons with no filters (recording.pmd)
areaFilter = false; %7668 polygons with all 3 (area<120)
%6470 (A<100), surface still has great fidelity
depthFilter = false; %7882 polygons with difFilt
differenceFilter = true; %7889 polygons alone
resThresh = 5;

key = 'y';

while(key == 'y')
    clf
    hold on
    for i = 1:(length(dist(:,1))-1) % i = row
        for j = 1:(length(dist(1,:))-1) % j= column
            if(~depthFilter || dist(i,j) < 1.2 && dist(i+1,j) < 1.2 && ...
                    dist(i,j+1) < 1.2 && dist(i+1,j+1) < 1.2)
    %             disp(dist(i,j))
                point1 = [i,j,dist(i,j)];
                point2 = [i+1,j,dist(i+1,j)];
                point3 = [i,j+1,dist(i,j+1)];
                triangleT = [point1',point2',point3'];

                point4 = [i+1,j,dist(i+1,j)];
                point5 = [i,j+1,dist(i,j+1)];
                point6 = [i+1,j+1,dist(i+1,j+1)];
                triangleB = [point4',point5',point6'];
                colorT = [1 1 0];
                colorB = [1 0 1];
                if(~areaFilter || triangleArea3d(triangleT(1,:), ...
                                      triangleT(2,:),triangleT(3,:)) < 135 ...
                    && triangleArea3d(triangleB(1,:),triangleB(2,:), ...
                                                     triangleB(3,:)) < 135)
                    if(~differenceFilter ||... 
                        abs(point1(3) - point2(3)) < .1 && ...
                        abs(point2(3) - point3(3)) < .1 && ...
                        abs(point1(3) - point3(3)) < .1 && ...
                        abs(point4(3) - point5(3)) < .1 && ...
                        abs(point4(3) - point6(3)) < .1 && ...
                        abs(point5(3) - point6(3)) < .1)
                        
                        %Matrix without out noise data
                        triangleMat(i,j) = dist(i,j); %Top-left point
                        triangleMat(i+1,j) = dist(i+1,j); %Top-right point
                        triangleMat(i,j+1) = dist(i,j+1); %Bot-Left point
                        triangleMat(i+1,j+1) = dist(i+1,j+1); %Bot-right point
                        
                        fill3([i,i+1,i],[j,j,j+1],[triangleMat(i,j), ...
                                 triangleMat(i+1,j),triangleMat(i,j+1)],colorT);
                               
                        fill3([i+1,i,i+1],[j,j+1,j+1],[triangleMat(i+1,j), ...
                                   triangleMat(i,j+1),triangleMat(i+1,j+1)],colorB);       
                               
                        
                        % plot
%                         fill3(triangleT(1,:),triangleT(2,:), ...
%                                                       -triangleT(3,:),colorT);
%                         fill3(triangleB(1,:),triangleB(2,:), ...
%                                                       -triangleB(3,:),colorB);
                        
                        % store index (i,j) values every polygon kept after
                        % noise filters
                        if exist('polygonCount')
                            polygonCount(end+1,1:2) = [i,j];
                            normal(end+1,1:3) = cross(point1-point3,point1-point6);
                        else
                            polygonCount(1,1:2) = [i,j];
                            normal(1,1:3) = cross(point1-point3,point1-point6);
                        end
                        
                        centroid = [(point1(1)+point2(1))/2, (point1(2)+point3(2))/2, ...
                            mean([dist(i,j),dist(i+1,j),dist(i+1,j+1),dist(i,j+1)])];
                        %quiver3(centroid(1), centroid(2),  centroid(3), ...
                                 %normal(1), normal(2), normal(3))
                        
                    end
                end
            end
        end
    end
    pmdUpdate(hndl);
    dist = pmdGetDistances(hndl);
    disp('press y to continue');
%     key = getkey;
key = 'n';
end

pmdClose(hndl);

areas = nan(resThresh^2,2);                                                                                    

for xgrid = resThresh:resThresh:length(dist(1,:))-2*resThresh
    for ygrid = resThresh:resThresh:length(dist(:,1))-2*resThresh
        for blockX = 1:resThresh
            for blockY = 1:resThresh
                polygonIndex(blockX, blockY) = find(ismember(polygonCount,[xgrid+blockX, ygrid+blockY]),1);
                blockAreas(blockX, blockY,:) = polygonCount(polygonIndex(blockX, blockY));
                blockNormals(blockX, blockY,:) = normal(polygonIndex(blockX, blockY));
            end
        end
        
            bigPolygonNormal((xgrid+ygrid)/(2*resThresh),:) = mean(blockNormals(xgrid,ygrid));
            bigPolygonCentroid((xgrid+ygrid)/(2*resThresh),:) = [xgrid+resThresh/2, ygrid+resThresh/2];
            keyboard
        
        
    end
end
    
for t = 1 : length(bigPolygonNormal(:,1))
    quiver3(bigPolygonCentroid(t,1), bigPolygonCentroid(t,2), bigPolygonCentroid(t,3), ...
        bigPolygonNormal(t,1), bigPolygonNormal(t,2), bigPolygonNormal(t,3))
end




