function ground = plane1(frames)

%%input how many frames you wish to map, 1 for 1 picture and so on

    global originx originy
    figure(1);

    hold on
    originx = 0;
    originy = 0;
    for frame = 1:frames
        if(frame > 1)
            fstepx = input('x movement: ');
            fstepy = input('y movement: ');
        else
            fstepx = 0;
            fstepy = 0;
        end

        %%This line allows you to display an already taken depth image
        %%so uncomment it to check how it looks like if you don't have a
        %%camera
      hndl = pmdOpen('pmdfile.W64.pcp','bowl (2).pmd','camboardnanoproc.W64.ppp',''); 
%         hndl = pmdOpen('camboardnano.W64.pap','','camboardnanoproc.W64.ppp','');

        pmdUpdate(hndl);
        dist = pmdGetDistances(hndl);
        pmdClose(hndl);        
       
        %figure out copying method to save map instead of just plotting it
       
        %extra filters
        % need filter based on number of surrounding triangles, if too few
        % then SM clearly can't step there, so remove them
        % Also for if the square planes have no neighbors

        %turn on to filter out noise and bad pixels
        depthFilter = true;
        differenceFilter = true;
        
        squareMat = nan(length(dist(:,1)),length(dist(1,:)));
       
        for i = 1:(length(dist(:,1))-1) % i = row
            for j = 1:(length(dist(1,:))-1) % j= column
                %If depthfilter==true then remove points that are too far
                if(~depthFilter || dist(i,j) < 1.2 && dist(i+1,j) < 1.2 && ...
                        dist(i,j+1) < 1.2 && dist(i+1,j+1) < 1.2)

                   %Points are in a square form
                   %pt1---pt2
                   %|    |
                   %pt3--pt4

                    pt1 = [i,j,dist(i,j)];
                    pt2 = [i+1,j,dist(i+1,j)];
                    pt3 = [i,j+1,dist(i,j+1)];
                    pt4 = [i+1,j,dist(i+1,j)];

                   %Filter out polygons whose points differ in depth greatly
                    if(~differenceFilter ||... 
                        abs(pt1(3) - pt2(3)) < .05 && ...
                        abs(pt1(3) - pt3(3)) < .05 && ...
                        abs(pt1(3) - pt4(3)) < .05 && ...
                        abs(pt2(3) - pt3(3)) < .05 && ...
                        abs(pt2(3) - pt4(3)) < .05 && ...
                        abs(pt3(3) - pt4(3)) < .05 )

                        %Matrix without out noise data
                        squareMat(i,j) = dist(i,j); %Top-left point
                        squareMat(i+1,j) = dist(i+1,j); %Top-right point
                        squareMat(i,j+1) = dist(i,j+1); %Bot-Left point
                        squareMat(i+1,j+1) = dist(i+1,j+1); %Bot-right point

                    end
                end
            end
        end

        adjSquareThresh = 1;

        %removes singular squares
        %Checks in this pattern
        % \|/   123 
        % -S-   4S5
        % /|\   678    
        for i = 1:length(squareMat(:,1))-1
            for j = 1:length(squareMat(1,:))-1
                adjSquareCount = 0;
                if(isSquare(squareMat,i-1,j-1,length(squareMat(:,1)),length(squareMat(1,:))))
                    adjSquareCount = adjSquareCount + 1;
                end
                if(isSquare(squareMat,i,j-1,length(squareMat(:,1)),length(squareMat(1,:))))
                    adjSquareCount = adjSquareCount + 1;            
                end
                if(isSquare(squareMat,i+1,j-1,length(squareMat(:,1)),length(squareMat(1,:))))
                    adjSquareCount = adjSquareCount + 1;            
                end
                if(isSquare(squareMat,i-1,j,length(squareMat(:,1)),length(squareMat(1,:))))
                    adjSquareCount = adjSquareCount + 1;            
                end
                if(isSquare(squareMat,i+1,j,length(squareMat(:,1)),length(squareMat(1,:))))
                    adjSquareCount = adjSquareCount + 1;            
                end
                if(isSquare(squareMat,i-1,j+1,length(squareMat(:,1)),length(squareMat(1,:))))
                    adjSquareCount = adjSquareCount + 1;            
                end
                if(isSquare(squareMat,i,j+1,length(squareMat(:,1)),length(squareMat(1,:))))
                    adjSquareCount = adjSquareCount + 1;            
                end
                if(isSquare(squareMat,i+1,j+1,length(squareMat(:,1)),length(squareMat(1,:))))
                    adjSquareCount = adjSquareCount + 1;
                end
                if(adjSquareCount < adjSquareThresh)            
                    squareMat(i,j) = nan;
                    squareMat(i+1,j) = nan;
                    squareMat(i,j+1) = nan;
                    squareMat(i+1,j+1)= nan;
                end
            end
        end    
        %%change this between 2 and 10 for different resolutions
        bigSquareSize = 10;
        %Concatenate smaller squares into bigger ones
        %and draws those bigger squares
        ground = concatenate(squareMat, bigSquareSize,fstepx,fstepy); 
        pause(1);
        originx = fstepx;
        originy = fstepy;
    end
end

